%%%
%%% Author:
%%%   Andreas Franke <afranke@ags.uni-sb.de>
%%%
%%% Copyright:
%%%   Andreas Franke, 1999
%%%
%%% Last change:
%%%   $Date: 2000/01/16 06:08:17 $ by $Author: afranke $
%%%   $Revision: 1.1 $
%%%
%%% This file is part of MathWeb
%%%    http://www.mathweb.org/mathweb
%%%
%%% See the file "LICENSE" or
%%%    http://www.mathweb.org/mathweb/LICENSE.html
%%% for information on usage and redistribution
%%% of this file, and for a DISCLAIMER OF ALL
%%% WARRANTIES.
%%%

functor
   
import
   System(eq:Eq)
   
export
   'class': FIFO

define
   
   class FIFO
      
      attr
         list
         tail
         
      meth init
         L in
         list <- L
         tail <- L
      end
      meth put(X)
         T in
         @tail = X|T
         tail <- T
      end
      meth get(?X)
         if {Eq @list @tail}
         then X=false
         else
            !X|R = @list in
            list <- R
         end
      end
      meth getAll(?L)
         @tail = nil
         L = @list
         FIFO, init
      end
   end

end
