%%%
%%% Author:
%%%   Andreas Franke <afranke@ags.uni-sb.de>
%%%
%%% Copyright:
%%%   Andreas Franke, 1999
%%%
%%% Last change:
%%%   $Date: 2000/01/16 06:08:21 $ by $Author: afranke $
%%%   $Revision: 1.1 $
%%%
%%% This file is part of MathWeb
%%%    http://www.mathweb.org/mathweb
%%%
%%% See the file "LICENSE" or
%%%    http://www.mathweb.org/mathweb/LICENSE.html
%%% for information on usage and redistribution
%%% of this file, and for a DISCLAIMER OF ALL
%%% WARRANTIES.
%%%

%%
%% dtd2pickle.oz
%%

functor

import
   Application System Pickle
   
   DtdInput(readDtd: ReadDtd) at 'DtdInput.ozf'
   
define
   AppName = 'dtd2pickle'
   
   Spec = record() 
   Args
   try
      Args = {Application.getArgs Spec}
   catch error(ap(usage S)...) then
      {System.showError AppName#": "#S}
      {Application.exit 1}
   end
   
   fun {IsSuffix S Suffix}
      {List.isPrefix {Reverse Suffix} {Reverse S}}
   end
   fun {DropSuffix S Suffix}
      if {IsSuffix S Suffix}==false then S
      else
         {Reverse {List.drop {Reverse S} {Length Suffix}}}
      end
   end
   fun {MakeIO X}
      BaseName = {DropSuffix X ".dtd"} in
      (BaseName#".dtd")#(BaseName#".dtd.ozp")
   end
        
   IOs = case Args.1 of nil then ['stdin'#'stdout']
         [] L then {Map L MakeIO} end

   {ForAll IOs proc {$ I#O} {Pickle.save {ReadDtd I} O} end}
   {Application.exit 0}
end



