%%%
%%% Author:
%%%   Andreas Franke <afranke@ags.uni-sb.de>
%%%
%%% Copyright:
%%%   Andreas Franke, 1999
%%%
%%% Last change:
%%%   $Date: 2000/01/16 06:08:22 $ by $Author: afranke $
%%%   $Revision: 1.1 $
%%%
%%% This file is part of MathWeb
%%%    http://www.mathweb.org/mathweb
%%%
%%% See the file "LICENSE" or
%%%    http://www.mathweb.org/mathweb/LICENSE.html
%%% for information on usage and redistribution
%%% of this file, and for a DISCLAIMER OF ALL
%%% WARRANTIES.
%%%

%%
%% pickle2dtd.oz
%%

functor

import
   Application System Open Pickle Property
   
   DtdOutput(writeDtd:WriteDtd) at 'DtdOutput.ozf'
   
define
   AppName = 'pickle2dtd'
   
   Spec = record()
   Args
   try
      Args = {Application.getArgs Spec}
   catch error(ap(usage S)...) then
      {System.showError AppName#": "#S}
      {Application.exit 1}
   end

   fun {IsSuffix S Suffix}
      {List.isPrefix {Reverse Suffix} {Reverse S}}
   end
   fun {DropSuffix S Suffix}
      if {IsSuffix S Suffix}==false then S
      else
         {Reverse {List.drop {Reverse S} {Length Suffix}}}
      end
   end
   fun {MakeIO X}
      BaseName = {DropSuffix {DropSuffix X ".ozp"} ".dtd"} in
      (BaseName#".dtd.ozp")#(BaseName#".dtd.core")
   end
        
   IOs = case Args.1 of nil then ['stdin'#'stdout']
         [] L then {Map L MakeIO} end
   
   proc {SaveVS VS FileName}
      F = {New Open.file init(name:FileName flags:[write create truncate])} in
      {F write(vs:VS)}
      {F close}
   end
   
   {Property.put 'errors.depth' 100}
   {Property.put 'errors.width' 100}
   
   {ForAll IOs proc {$ I#O} {SaveVS {WriteDtd {Pickle.load I}} O} end}
   {Application.exit 0}
end



